#ifndef CHIP_MMAP_H
#define CHIP_MMAP_H

/* CODE MEMORY */
#define CHIP_MEMRGN_ADDR_FLASH                0x00000000UL
/* RAM */
#define CHIP_MEMRGN_ADDR_SRAM0                0x10000000UL
#define CHIP_MEMRGN_ADDR_SRAM1                0x20000000UL
#define CHIP_MEMRGN_ADDR_SRAM2                0x20004000UL

#define CHIP_MEMRGN_ADDR_MTB                  0x14001000
#define CHIP_MEMRGN_ADDR_BOOTROM              0x1FFF0000

/* Peripherals */
#define CHIP_MEMRGN_ADDR_APB                  0x40000000UL

#define CHIP_MEMRGN_ADDR_PERIPH_USB           0x40080000UL
#define CHIP_MEMRGN_ADDR_PERIPH_CRC           0x50000000UL
#define CHIP_MEMRGN_ADDR_PERIPH_DMA           0x50004000UL
#define CHIP_MEMRGN_ADDR_PERIPH_SCT0          0x5000C000UL
#define CHIP_MEMRGN_ADDR_PERIPH_SCT1          0x5000E000UL
#define CHIP_MEMRGN_ADDR_PERIPH_GPIO          0xA0000000UL
#define CHIP_MEMRGN_ADDR_PERIPH_GPIO_PINT     0xA0004000UL

#define CHIP_MEMRGN_ADDR_CM0_INTERNAL         0xE0000000UL


#define CHIP_MEMRGN_ADDR_PERIPH_I2C0          (CHIP_MEMRGN_ADDR_APB + 0x00000000)
#define CHIP_MEMRGN_ADDR_PERIPH_WWDT          (CHIP_MEMRGN_ADDR_APB + 0x00004000)
#define CHIP_MEMRGN_ADDR_PERIPH_USART0        (CHIP_MEMRGN_ADDR_APB + 0x00008000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM16_0       (CHIP_MEMRGN_ADDR_APB + 0x0000C000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM16_1       (CHIP_MEMRGN_ADDR_APB + 0x00010000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM32_0       (CHIP_MEMRGN_ADDR_APB + 0x00014000)
#define CHIP_MEMRGN_ADDR_PERIPH_TIM32_1       (CHIP_MEMRGN_ADDR_APB + 0x00018000)
#define CHIP_MEMRGN_ADDR_PERIPH_ADC           (CHIP_MEMRGN_ADDR_APB + 0x0001C000)
#define CHIP_MEMRGN_ADDR_PERIPH_I2C1          (CHIP_MEMRGN_ADDR_APB + 0x00020000)
#define CHIP_MEMRGN_ADDR_PERIPH_RTC           (CHIP_MEMRGN_ADDR_APB + 0x00024000)
#define CHIP_MEMRGN_ADDR_PERIPH_DMA_TRIGMUX   (CHIP_MEMRGN_ADDR_APB + 0x00028000)
#define CHIP_MEMRGN_ADDR_PERIPH_PMU           (CHIP_MEMRGN_ADDR_APB + 0x00038000)
#define CHIP_MEMRGN_ADDR_PERIPH_FLASH         (CHIP_MEMRGN_ADDR_APB + 0x0003C000)
#define CHIP_MEMRGN_ADDR_PERIPH_SSP0          (CHIP_MEMRGN_ADDR_APB + 0x00040000)
#define CHIP_MEMRGN_ADDR_PERIPH_IOCON         (CHIP_MEMRGN_ADDR_APB + 0x00044000)
#define CHIP_MEMRGN_ADDR_PERIPH_SYSCON        (CHIP_MEMRGN_ADDR_APB + 0x00048000)
#define CHIP_MEMRGN_ADDR_PERIPH_USART4        (CHIP_MEMRGN_ADDR_APB + 0x0004C000)
#define CHIP_MEMRGN_ADDR_PERIPH_SSP1          (CHIP_MEMRGN_ADDR_APB + 0x00058000)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIO_GROUP0   (CHIP_MEMRGN_ADDR_APB + 0x0005C000)
#define CHIP_MEMRGN_ADDR_PERIPH_GPIO_GROUP1   (CHIP_MEMRGN_ADDR_APB + 0x00060000)
#define CHIP_MEMRGN_ADDR_PERIPH_USART1        (CHIP_MEMRGN_ADDR_APB + 0x0006C000)
#define CHIP_MEMRGN_ADDR_PERIPH_USART2        (CHIP_MEMRGN_ADDR_APB + 0x00070000)
#define CHIP_MEMRGN_ADDR_PERIPH_USART3        (CHIP_MEMRGN_ADDR_APB + 0x00074000)


#endif // CHIP_MMAP_H
